##
 # raycast_campfire.mcfunction
 #
 # This raycasting function allows for edge cases where the recipe will go through but no function will fire, cba finding a solution for that
 #
 # Edited by mmcculloch101.
##
# If we find a Campfire that is enabled move to the cooking function only if the random chance gets met
execute if score use_soul_campfire campfire_settings matches 1 if block ~ ~ ~ minecraft:soul_campfire[lit=true] align xyz positioned ~0.5 ~0.5 ~0.5 if predicate sch:soul_campfire_haunt/random_chance run function sch:soul_campfire_haunt/cook
execute if score use_campfire campfire_settings matches 1 if block ~ ~ ~ minecraft:campfire[lit=true] align xyz positioned ~0.5 ~0.5 ~0.5 if predicate sch:soul_campfire_haunt/random_chance run function sch:soul_campfire_haunt/cook

# If we find a Campfire that is disabled move to the canceling function
execute if score use_soul_campfire campfire_settings matches 0 if block ~ ~ ~ minecraft:soul_campfire[lit=true] as @s run function sch:soul_campfire_haunt/cancel
execute if score use_campfire campfire_settings matches 0 if block ~ ~ ~ minecraft:campfire[lit=true] as @s run function sch:soul_campfire_haunt/cancel

execute if score debug campfire_settings matches 1 if block ~ ~ ~ #minecraft:campfires[lit=true] as @s run function sch:soul_campfire_haunt/cook

# If we find air move 0.1 blocks forward and try again
execute unless block ~ ~ ~ #minecraft:campfires[lit=true] positioned ^ ^ ^0.1 run function sch:soul_campfire_haunt/raycast_campfire
